(define (binary-tree->list tree) 
  ; Space: Theta(n)
  ; Time: Theta(n^2)   (because append! is Theta(n) in time)
  (check-binary-tree tree)
  (if (empty-binary-tree? tree)
      '()
      (append! (binary-tree->list (left-subtree tree))
               (list (node-value tree))
               (binary-tree->list (right-subtree tree)))))